SystemOrganization addCategory: #'ShoreComponents-Kernel'!
SystemOrganization addCategory: #'ShoreComponents-Support'!
SystemOrganization addCategory: #'ShoreComponents-Dialogs'!
SystemOrganization addCategory: #'ShoreComponents-Hierarchy'!
SystemOrganization addCategory: #'ShoreComponents-Lists'!
SystemOrganization addCategory: #'ShoreComponents-XPPanel'!
SystemOrganization addCategory: #'ShoreComponents-Useful'!
SystemOrganization addCategory: #'ShoreComponents-Editors'!
SystemOrganization addCategory: #'ShoreComponents-Demo1'!
SystemOrganization addCategory: #'ShoreComponents-Libraries'!
SystemOrganization addCategory: #'ShoreComponents-EmbeddedBrowser'!
SystemOrganization addCategory: #'ShoreComponents-Timetables'!

WAComponent subclass: #ShoreComponent
	instanceVariableNames: 'parent attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

ShoreComponent class
	instanceVariableNames: 'id'!

ShoreComponent subclass: #ShoreBatchedList
	instanceVariableNames: 'title page pageSize data itemBlock noteBlock sorters activeSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Lists'!

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:12'!
activeSorter
	^activeSorter! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:33'!
activeSorter: sorterName

	activeSorter := sorterName.
	self data: self data.! !

!ShoreBatchedList methodsFor: 'sorting' stamp: 'pk 7/2/2005 19:44'!
addSorter: name block: sortBlock

	sorters add: (name -> sortBlock).
! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
data
	^data! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/2/2005 19:54'!
data: anObject

	activeSorter ifNil: [ 
		data := anObject.
		^ self ].

	data := anObject sortBy: activeSorter value

	! !

!ShoreBatchedList methodsFor: 'initialization' stamp: 'pk 7/2/2005 19:38'!
initialize 

	super initialize. 
	self session registerObjectForBacktracking: self. 

	page := 1.
	pageSize := 15.
	title := 'List' translated.
	sorters := OrderedCollection  new.
	activeSorter := nil.! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
itemBlock
	^itemBlock! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
itemBlock: anObject
	itemBlock := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/2/2005 19:34'!
noteBlock
	^noteBlock! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/2/2005 19:34'!
noteBlock: anObject
	noteBlock := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
page
	^page! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
pageSize
	^pageSize! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
pageSize: anObject
	pageSize := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:57'!
page: anObject
	page := anObject! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 7/2/2005 22:48'!
renderContentOn: html 

	| pageData pagesCount | 

	pagesCount := (data size-1)//pageSize+1. 
	pageData := data copyFrom: (((page-1)*pageSize+1) max: 1) to: (((page)*pageSize) min: data size). 

	html divClass: #shoreBatchedList with: [ 
		html divClass: #shoreBatchedListNavigation with: [
			self renderSortersOn: html  .
			html text: title.].

			pageData do: [:item | 
				html div:[
				html divClass: #shoreBatchedListItem with: [
					itemBlock
						ifNil: [ html text: item asString]
						ifNotNil: [ itemBlock value: item value: html ].].
				noteBlock
					ifNotNil: [ html divClass: #shoreBatchedListItemNote with: [
						noteBlock value: item value: html ] ] ].
				html break. ].


		html divClass: #shoreBatchedListNavigation with: [
			html text: ('[{1}/{2}]' format: { page. pagesCount }). 
			html space. 
			(page <= 1) 
				ifFalse: [html anchorWithAction: [page := page -1] text: '<'. html space ]. 
			(page >= pagesCount) 
				ifFalse: [html anchorWithAction: [page := page + 1] text: '>' ] ] ].. ! !

!ShoreBatchedList methodsFor: 'rendering' stamp: 'pk 7/2/2005 19:55'!
renderSortersOn: html

	| names |

	names := sorters asOrderedCollection.

	names ifNotEmpty: [
		html divClass: #shoreBatchedListSorters with: [
			html  text: '(sort by '.
			names allButLastDo: [:sorter |
				html anchorWithAction: [ self activeSorter: sorter] 
					text: sorter key asString.
				html text: ', '].
			html anchorWithAction: [ self activeSorter: names last] 
					text: names last key asString.

			html text: ')'. ] ]! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:11'!
setSorter: sorterName

	activeSorter := sorterName
! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:02'!
sorters
	^sorters! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 7/1/2005 19:02'!
sorters: anObject
	sorters := anObject! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
title
	^title! !

!ShoreBatchedList methodsFor: 'accessing' stamp: 'pk 6/29/2005 22:58'!
title: anObject
	title := anObject! !

!ShoreComponent class methodsFor: 'instance creation' stamp: 'pk 6/29/2005 19:51'!
new

	self canBeRoot 
		ifTrue: [ ^ super new ]
		ifFalse: [ self error: 'use parent:'. ].	
	! !

!ShoreComponent class methodsFor: 'identifiers' stamp: 'pk 6/29/2005 19:47'!
newId

	" generates new unique identifier for html element etc "

	id ifNil: [ id := 0 ].
	id > 1048576 ifTrue: [ id := 0 ].
	id := id + 1.
	^ 'eid', id asString.
		! !

!ShoreComponent class methodsFor: 'instance creation' stamp: 'pk 6/29/2005 19:42'!
parent: aComponent

	^ (super basicNew parent: aComponent) initialize.! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 7/3/2005 16:04'!
addAttribute: attributeAssociation category: aCategoryName
	
	(self ensureCategory: aCategoryName) 
		add: attributeAssociation.! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 6/29/2005 20:32'!
addFormAttribute: attributeAssociation

	self addAttribute: attributeAssociation category: #formAttributes
	! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 6/29/2005 20:56'!
attributes

	^attributes ifNil: [ Dictionary new ].! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 6/29/2005 20:10'!
attributes: anObject
	attributes := anObject! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 20:44'!
call: aComponent

	| result |
	result := super call: aComponent.
	self pageTitle ifNotNil: [self pageTitle: self pageTitle].
	^ result! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 6/29/2005 21:41'!
confirm: aString

	^ self defaultTarget call: ((ShoreConfirmDialog parent: self defaultTarget) msg: aString)! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 21:40'!
defaultTarget

	^ self root! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 7/3/2005 16:12'!
ensureAttributes

	attributes ifNil: [ attributes := Dictionary new ].
	^ self attributes.
	! !

!ShoreComponent methodsFor: 'attributes' stamp: 'pk 7/3/2005 16:13'!
ensureCategory: aCategoryName
	
	^ self ensureAttributes at: aCategoryName ifAbsentPut: [Dictionary new].
! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 6/29/2005 21:42'!
error: aString

	self defaultTarget call: ((ShoreErrorDialog parent: self defaultTarget) msg: aString)
! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:49'!
footer

	^ (parent respondsTo: #footer)
			ifTrue: [ parent footer ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 6/29/2005 20:37'!
formId

	^ (self formRoot attributes at: #formAttributes) at: #id.
	


	! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 6/29/2005 22:40'!
formOn: html with: aBlock

	self formRoot == self 
		ifTrue: [
			| formAttributes |

			formAttributes := self attributes at: #formAttributes 
				ifAbsentPut: (Dictionary newFrom: {#id -> self class newId}).

			formAttributes associationsDo: [ :attribute |
				html attributeAt: attribute key put: attribute value.
				].
			html form: aBlock. ]
		ifFalse: [
			html div: aBlock ]	! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 6/29/2005 21:01'!
formRoot 

	" returns root component of the form 

	if your component uses form, redefine this method like this:

	^ self formRootOrSelf
	"

	^ (parent respondsTo: #formRoot) 
		ifTrue: [ parent formRoot ] 
		ifFalse: [ nil ].! !

!ShoreComponent methodsFor: 'forms' stamp: 'pk 6/29/2005 22:38'!
formRootOrSelf 

	| formRoot | 
	formRoot := (parent respondsTo: #formRoot) 
		ifTrue: [ parent formRoot ] 
		ifFalse: [ nil ]. 

	^ formRoot ifNil: [ self ].

! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:49'!
header

	^ (parent respondsTo: #header)
			ifTrue: [ parent header ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 6/29/2005 21:41'!
inform: aString

	self defaultTarget call: ((ShoreInformDialog parent: self defaultTarget) msg: aString)! !

!ShoreComponent methodsFor: 'initialization' stamp: 'pk 7/3/2005 09:39'!
initialize

	super initialize.

	self pageTitle ifNotNil: [self pageTitle: self pageTitle].! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:50'!
leftPannel

	^ (parent respondsTo: #leftPannel)
			ifTrue: [ parent leftPannel ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:51'!
mainPannel

	^ (parent respondsTo: #mainPannel)
			ifTrue: [ parent mainPannel ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 09:38'!
pageTitle

	^ nil.! !

!ShoreComponent methodsFor: 'convenience' stamp: 'pk 7/3/2005 09:34'!
pageTitle: title

	self header ifNotNilDo: [:header | header subtitle: title ].

	! !

!ShoreComponent methodsFor: 'accessing' stamp: 'pk 6/29/2005 20:10'!
parent
	^parent! !

!ShoreComponent methodsFor: 'accessing' stamp: 'pk 6/29/2005 20:10'!
parent: anObject
	parent := anObject! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:48'!
realRoot

	^ (parent respondsTo: #realRoot)
			ifTrue: [ parent realRoot ]
			ifFalse: [ self ].! !

!ShoreComponent methodsFor: 'renderer' stamp: 'pk 6/29/2005 20:11'!
rendererClass 

	^ ShoreRenderer! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:51'!
rightPannel

	^ (parent respondsTo: #rightPannel)
			ifTrue: [ parent rightPannel ]
			ifFalse: [ self ]! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:48'!
root

	^ (parent respondsTo: #root)
			ifTrue: [ parent root ]
			ifFalse: [ self ].! !

!ShoreComponent methodsFor: 'caching' stamp: 'pk 7/3/2005 18:26'!
sessionCache

	^ self realRoot ensureCategory: #sessionCache.
! !

!ShoreComponent methodsFor: 'caching' stamp: 'pk 7/3/2005 18:26'!
sessionCacheAt: aSymbol ifAbsentPut: aBlock

	^ (self sessionCache at: aSymbol ifAbsentPut: [aBlock value]) url
			
	! !

!ShoreComponent methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 20:48'!
target

	^ (parent respondsTo: #target)
			ifTrue: [ parent target ]
			ifFalse: [ self ]! !

ShoreComponent subclass: #ShoreDayTimetable
	instanceVariableNames: 'timetableId items box'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Timetables'!

!ShoreDayTimetable methodsFor: 'items' stamp: 'pk 7/6/2005 17:59'!
addItem: anItem

	items add: anItem.! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:20'!
axisColor

	^ Color r: 0.455 g: 0.588 b: 0.887! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:26'!
axisFontColor

	^ Color white.! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 10:39'!
axisHeight

	^ 4 * self quarterHeight *24 ! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 10:13'!
axisWidth

	^ 20! !

!ShoreDayTimetable methodsFor: 'background' stamp: 'pk 7/6/2005 11:50'!
background

	| form  canvas |

	form := Form extent: self width@self height depth: 16.

	canvas := FormCanvas on: form.

	self drawBackgroundsOn: canvas.
	self drawLinesOn: canvas.
	self drawTextsOn: canvas.

	^ ShoreForm from: form! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:19'!
bottomColor

	^ Color r: 0.78 g: 0.831 b: 0.969! !

!ShoreDayTimetable methodsFor: 'accessing' stamp: 'pk 7/6/2005 19:45'!
boxId 

	^ box! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:15'!
brightnessDifference

	^ -0.08! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 14:15'!
columnWidth

	^ 70! !

!ShoreDayTimetable methodsFor: 'accessing' stamp: 'pk 7/6/2005 10:30'!
descriptions

	^ #()! !

!ShoreDayTimetable methodsFor: 'background' stamp: 'pk 7/6/2005 10:58'!
drawBackgroundsOn: canvas

	| color1 color2 |

	"backgrounds"
	canvas fillRectangle: (0@0 extent: self width@self headerHeight) color: self headerColor.
	canvas fillRectangle: (0@self headerHeight extent: self axisWidth@self axisHeight) color: self axisColor.

	color1 := self topColor.
	color2 := self bottomColor.

	1 to: self descriptions size do: [ :i |
		| style |	
		style := GradientFillStyle ramp: { 
			0.0 -> color1.
			1.0 -> color2 }.
		color1 := color1 adjustBrightness: self brightnessDifference.
		color2 := color2 adjustBrightness: self brightnessDifference.
		style origin: 0@0.
		style direction: (0 @ self axisHeight).
		canvas fillRectangle: ((self axisWidth+(self columnWidth*(i-1)))@self headerHeight extent: self columnWidth@self axisHeight) fillStyle:style.].! !

!ShoreDayTimetable methodsFor: 'background' stamp: 'pk 7/6/2005 11:40'!
drawLinesOn: canvas

	0 to: (self descriptions size -1) do: [:i |
		| x |
		x := self columnWidth*i+self axisWidth.
		canvas line: x@0 to: x@self height color: self linesColor.].

	1 to: 95 do: [:i |
		| y |
		i \\ 4 ~=0 ifTrue: [
			y := self quarterHeight*i+self headerHeight.
			canvas line: self axisWidth@y to: self width@y color: self quartersColor.] ].

	0 to: 23 do: [:i |
		| y |
		y := self quarterHeight*4*i+self headerHeight.
		canvas line: 0@y to: self width@y color: self linesColor.]
! !

!ShoreDayTimetable methodsFor: 'background' stamp: 'pk 7/6/2005 14:16'!
drawTextsOn: canvas

	0 to: 24 do: [:hour |
		canvas 
			drawString: hour asString 
			at: 2@(self headerHeight+(hour*self quarterHeight*4)) 
			font: self font color: 
			self axisFontColor.].

	self descriptions withIndexDo: [:desc :index |	
		canvas 
			drawString: desc asString 
			at: ((self axisWidth@0)+(((index-1)*self columnWidth+5)@2)) 
			font: self font color: 
			self headerFontColor.].! !

!ShoreDayTimetable methodsFor: 'fonts' stamp: 'pk 7/6/2005 09:40'!
font

	^ nil.! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 09:40'!
fontColor

	^ Color black.! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:20'!
headerColor

	^ Color r: 0.455 g: 0.588 b: 0.887! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:25'!
headerFontColor

	^ Color white.! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 11:51'!
headerHeight

	^ 20! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 10:39'!
height

	^ self headerHeight + self axisHeight! !

!ShoreDayTimetable methodsFor: 'initialization' stamp: 'pk 7/6/2005 19:45'!
initialize

	super initialize.

	timetableId := self class newId.
	items := OrderedCollection new.
	box := self class newId.
	! !

!ShoreDayTimetable methodsFor: 'accessing' stamp: 'pk 7/6/2005 10:04'!
items
	"Answer the value of items"

	^ items! !

!ShoreDayTimetable methodsFor: 'accessing' stamp: 'pk 7/6/2005 10:04'!
items: anObject
	"Set the value of items"

	items _ anObject! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 10:42'!
linesColor

	^ Color black.! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 11:51'!
quarterHeight

	^ 4! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:37'!
quartersColor

	^ Color lightGray.! !

!ShoreDayTimetable methodsFor: 'rendering' stamp: 'pk 7/6/2005 20:16'!
renderContentOn: html

	| background |	
	
	background := self sessionCacheAt: timetableId
		ifAbsentPut: [ html sessionEntryForDocument: (self background) ].

	html attributeAt: #style put: (('background-image: url({1}); width: {2}px; height: {3}px;') 
		format: { background. self width. self height }).

	html backgroundImage: background.
	html divClass: #shoreDayTimetable with: [
		self renderItemsOn: html ].

	html cssId: self boxId.
	html attributeAt: #style put: (('border: 2px solid black; width: {1}px; height: {2}px;') 
		format: { self width. 22}).
	html valueInputOfType: #text value: '' callback:[:v| ]..
! !

!ShoreDayTimetable methodsFor: 'rendering' stamp: 'pk 7/6/2005 22:22'!
renderItemsOn: html
	
	items do: [ :item |
		| sx sy ex ey |
		sx := (item column-1 * self columnWidth + self axisWidth) asInteger+1.
		ex := (item column * self columnWidth + self axisWidth) asInteger.
		sy := ((item interval start asTime asSeconds/900 * self quarterHeight) + self headerHeight) asInteger+1.
		ey := ((item interval end asTime asSeconds/900 * self quarterHeight) + self headerHeight) asInteger+1.
	"self halt."
		html rectangle: (sx@sy corner: ex@ey)
					class: 'shoreDayTimetableItem'
					color: item color
					onClick: (item action ifNil: [String new] ifNotNil: [
						'document.location.href = ''', (html urlForAction: item action), '''' ])
					onMouseOver: ('document.getElementById(''', self boxId, ''').value=''', item text, '''')
					onMouseOut: ('document.getElementById(''', self boxId, ''').value=''''')
					for: [].		
		].
	
	
! !

!ShoreDayTimetable methodsFor: 'accessing' stamp: 'pk 7/6/2005 10:02'!
timetableId
	"Answer the value of timetableId"

	^ timetableId! !

!ShoreDayTimetable methodsFor: 'accessing' stamp: 'pk 7/6/2005 10:02'!
timetableId: anObject
	"Set the value of timetableId"

	timetableId _ anObject! !

!ShoreDayTimetable methodsFor: 'colors' stamp: 'pk 7/6/2005 11:18'!
topColor

	^ Color r: 0.969 g: 0.977 b: 0.996.! !

!ShoreDayTimetable methodsFor: 'dimesnions' stamp: 'pk 7/6/2005 10:32'!
width 

	^ self axisWidth + (self descriptions size * self columnWidth)! !

ShoreDayTimetable subclass: #ShoreDemo1DayTimetable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1DayTimetable methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 10:54'!
descriptions

	^ { 'column 1' translated. 'column 2' translated. 'column 3' translated. 'column 4' translated}.

	! !

ShoreComponent subclass: #ShoreDemo1
	instanceVariableNames: 'header root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1 class methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2005 22:05'!
canBeRoot
	
	^ true! !

!ShoreDemo1 class methodsFor: 'as yet unclassified' stamp: 'pk 6/30/2005 19:51'!
initialize

	" ShoreDemo1 initialize "

	| app |

	app := self registerAsApplication: 'ShoreDemo1'.
	app libraries add: ShoreStandardStyles.! !

!ShoreDemo1 class methodsFor: 'as yet unclassified' stamp: 'pk 7/1/2005 08:00'!
logo

^ ShoreForm
	extent: 32@32
	depth: 32
	fromArray: #( 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278217170 4278199627 4278190080 4278190080 4278190080 4278190080 4278387456 4280032256 4282992896 4284374528 4288914176 4288914176 4293190656 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278208656 4278190854 4278190080 4278190080 4279374336 4284703488 4291940608 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278209430 4278190080 4278190080 4279571712 4289703680 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278219751 4278191113 4278190080 4282006016 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278209689 4278190080 4278650624 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278206334 4278190080 4280361216 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278210204 4278190080 4278650624 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278218977 4278190854 4278190080 4286808832 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278202464 4278190080 4278387456 4292664320 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278220266 4278193176 4278190080 4279111168 4294177536 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278215107 4278190854 4278190080 4280492800 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278211237 4278190080 4278190080 4282466560 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278207108 4278190080 4278190080 4289572096 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278198594 4278190080 4280821760 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278209430 4278190080 4279242752 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278204786 4278190080 4280427008 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278221040 4278192661 4278190080 4285098240 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278201690 4278190080 4278453248 4294374912 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278207367 4278190080 4278190080 4287993088 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278206593 4278190080 4278190080 4283387648 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222073 4278203238 4278190080 4278190080 4282137600 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278217944 4278197305 4278190080 4278190080 4283256064 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278208141 4278191113 4278190080 4278255872 4286545664 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278222847 4278217944 4278198079 4278190080 4278190080 4279176960 4290887936 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278222847 4278222847 4278220525 4278203497 4278190339 4278190080 4278190080 4283387648 4294769664 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278222847 4278222847 4278221040 4278206593 4278191887 4278190080 4278190080 4279571712 4290230016 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278221040 4278222847 4278217429 4278204271 4278191628 4278190080 4278190080 4278782208 4287532544 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278205045 4278196272 4278190080 4278190080 4278190080 4278650624 4285164032 4294769664 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4294967040 4293980160 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080)
	offset: 0@0! !

!ShoreDemo1 methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 09:14'!
children

	^ { header. root }.! !

!ShoreDemo1 methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 09:15'!
header

	^ header.


! !

!ShoreDemo1 methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 09:45'!
initialize

	super initialize.

	header := ShorePageHeader parent: self.
	header title: 'ShoreComponents Demonstration'.

	root := ShoreDemo1Root  parent: self.


	! !

!ShoreDemo1 methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 16:13'!
renderContentOn: html

	| logo |

	logo := self sessionCacheAt: #ShoreDemo1Logo 
		ifAbsentPut: [ html sessionEntryForDocument: (self class logo) ].

	header image: logo.
	html render: header.

	html render: root.



! !

!ShoreDemo1 methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 09:15'!
root

	^ root.


! !

ShoreComponent subclass: #ShoreDemo1BatcheListDemo
	instanceVariableNames: 'panel list1 list2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1BatcheListDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 10:30'!
children

	^ { list1. list2.}.! !

!ShoreDemo1BatcheListDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 10:30'!
initialize

	super initialize.

	list1 := ShoreBatchedList parent: self.
	list1 title: 'Shore Batched List'.
	list1 data: Smalltalk allClasses.

	list2 := ShoreBatchedList parent: self.
	list2 title: 'Shore Batched List'.
	list2 data: Smalltalk allClasses.
	list2 itemBlock: [ :item :html |
		html anchorWithAction: [ 
			self call: (WABrowser fullOnClass: item) ] 
		text: item asString ].
	list2 noteBlock: [ :item :html |
		html text: (item name size asString) ].

	list2 addSorter: 'name'  translated block: [:a :b | a name <= b name].
	list2 addSorter: 'descending' translated block: [:a :b | b name <= a name].




	! !

!ShoreDemo1BatcheListDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 10:34'!
pageTitle

	^ 'ShoreBatchedList demo' translated! !

!ShoreDemo1BatcheListDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:09'!
renderContentOn: html

	html heading: 'Batched list' translated.

	html paragraph: 'Simple batched list' translated.
	html render: list1.

	html paragraph: 'Batched list with actions, sorting and notes' translated.
	html render: list2.



! !

!ShoreDemo1BatcheListDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 10:29'!
style

	^ '

.leftPanel {
	vertical-align: top;
	width: 220px;
	margin: 0px; 
	padding: 0px;
	height: 100%;
	background-color: rgb(116, 150, 226);

}

.layoutTable {
	width: 100%;
	height: 100%;
	padding: 0px;
}

.main {
	width: 100%;
	padding: 5px;
	margin: 0px;
	margin-bottom: 0px;
	height: 100%;
	padding-bottom: 20px;
}





'! !

ShoreComponent subclass: #ShoreDemo1CacheDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1CacheDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 22:25'!
pageTitle

	^ 'Session cache demo' translated.! !

!ShoreDemo1CacheDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 22:29'!
renderContentOn: html

	| hour |	

	html heading: 'Session cache demo'.

	html paragraph: 'Noncached image (try to refresh page):' translated.
	html image: (html urlForDocument: (ShoreForm from: (WatchMorph new imageForm))).

	html paragraph: 'Cached image:' translated.
	hour := self sessionCacheAt: #ShoreDemo1CacheDemoHour 
		ifAbsentPut: [ html sessionEntryForDocument: (ShoreForm from: (WatchMorph new imageForm))].

	html image: hour! !

ShoreComponent subclass: #ShoreDemo1ComponentWithFrom
	instanceVariableNames: 'name surname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
formRoot
	
	^ self formRootOrSelf.! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:42'!
initialize

	super initialize.

	name := 'name' translated.
	surname := 'surname' translated.! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:41'!
name
	^name! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
name: anObject
	name := anObject! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:45'!
renderContentOn: html

	html divClass: #shoreDemo1ComponentWithFrom2 with: [
		self formOn: html with: [
			html table: [
				html tableRowWithLabel: 'Name:' translated 
					column:  [html textInputOn: #name of: self].
				html tableRowWithLabel: 'Surname:' translated 
					column:  [html textInputOn: #surname of: self] ].
			html buttons: [ html submitButton ] ].
	].! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:41'!
style

	^ '
.shoreDemo1ComponentWithFrom2 { background: #c6d3f7 }
'! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
surname
	^surname! !

!ShoreDemo1ComponentWithFrom methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:08'!
surname: anObject
	surname := anObject! !

ShoreComponent subclass: #ShoreDemo1ComponentWithFrom2
	instanceVariableNames: 'person description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:46'!
children

	^ { person }! !

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:23'!
description
	^description! !

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:23'!
description: anObject
	description := anObject! !

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:16'!
formRoot
	
	^ self formRootOrSelf.! !

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:43'!
initialize

	super initialize.

	person := ShoreDemo1ComponentWithFrom parent: self.
	description := 'description' translated.! !

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:45'!
renderContentOn: html

	html divClass: #shoreDemo1ComponentWithFrom with: [
		self formOn: html with: [
			html table: [
				html tableRowWithLabel: 'Person:' translated 
					column:  [html render: person.].
				html tableRowWithLabel: 'Description:' translated 
					column:  [html textInputOn: #description of: self] ].
			html buttons: [ html submitButton ] ].
	].! !

!ShoreDemo1ComponentWithFrom2 methodsFor: 'accessing' stamp: 'pk 7/3/2005 21:40'!
style

	^ '
.shoreDemo1ComponentWithFrom { background: #ecf1fd }
'! !

ShoreComponent subclass: #ShoreDemo1DayTimetableDemo
	instanceVariableNames: 'timetable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1DayTimetableDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 08:30'!
children

	^ { timetable }! !

!ShoreDemo1DayTimetableDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 22:27'!
initialize

	| item1 item2 |
	super initialize.

	timetable := ShoreDemo1DayTimetable parent: self.

	item1 := ShoreDayTimetableItem from: '7:30' asTime to: '17:45' asTime column: 1 text: 'red Item' translated color: 'red'.
	item1 action: [ self inform: 'red item'].

	item2 := ShoreDayTimetableItem from: '12:00' asTime to: '21:15' asTime column: 3 text: 'yellow Item' translated color: 'yellow'.
	item2 action: [ self inform: 'yellow item'].

	timetable addItem: item1.
	timetable addItem: item2.
! !

!ShoreDemo1DayTimetableDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 08:30'!
pageTitle

	^ 'Day timetable demo' translated! !

!ShoreDemo1DayTimetableDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 08:30'!
renderContentOn: html

	html heading: 'Day timetable' translated.

	html render: timetable.
	! !

ShoreComponent subclass: #ShoreDemo1DemosMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1DemosMenu methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:38'!
name

	^ 'Demos menu'.! !

!ShoreDemo1DemosMenu methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 08:31'!
renderContentOn: html

	html evaluatedList: {
		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1Introduction  parent: self target)]
			text: 'Introduction' translated ] }.	

	html evaluatedList: {
		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1StandardDialogsDemo  parent: self target)]
			text: 'Stadard dialogs' translated ]. 

		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1NestedFormsDemo  parent: self target)]
			text: 'Nested forms' translated ]. 

		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1BatcheListDemo parent: self target)]
			text: 'Batched list' translated ]. 

		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1RichEditDemo parent: self target)]
			text: 'Rich edit' translated ]. 

		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1EmbeddedBrowserDemo parent: self target)]
			text: 'Embedded Browser' translated ]. 

		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1DayTimetableDemo parent: self target)]
			text: 'Day timetable' translated ]. 

		[ html anchorWithAction: [ 
			self target show: (ShoreDemo1CacheDemo parent: self target)]
			text: 'Session cache' translated ]. 



}! !

ShoreComponent subclass: #ShoreDemo1EmbeddedBrowserDemo
	instanceVariableNames: 'browser websites'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'accessing' stamp: 'tbn 7/5/2005 11:13'!
children

	^ { browser }.! !

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'initialization' stamp: 'tbn 7/5/2005 11:32'!
initialize
	super initialize.
	browser := ShoreEmbeddedBrowser  parent: self.
	websites := Dictionary new
						at: 'Seaside' put: 'http://www.seaside.st';
						at: 'Squeak Swiki' put: 'http://minnow.cc.gatech.edu/squeak';
						at: 'Squeak Homepage' put: 'http://www.squeak.org';
						at: 'Seaside Mailinglist Archive' put: 'http://lists.squeakfoundation.org/pipermail/seaside/';
						at: 'Squeak Mailinglist Archive' put: 'http://lists.squeakfoundation.org/pipermail/squeak-dev/';
						at: 'Planet Smalltalk' put: 'http://planet.smalltalk.org/';
						at: 'Squeaksource' put: 'http://www.squeaksource.com/';
						at: 'SqueakMap' put: 'http://map1.squeakfoundation.org/sm/';
						yourself! !

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'accessing' stamp: 'tbn 7/5/2005 09:58'!
pageTitle
	"Returns the receivers page title"

	^'Embedded Browser'! !

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'rendering' stamp: 'tbn 7/5/2005 12:40'!
renderContentOn: html 
	html heading: 'Embedded Browser' translated.
	self renderSelectionOn: html.
	html spanNamed: 'selection' with: [html render: browser]! !

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'rendering' stamp: 'pk 7/5/2005 13:50'!
renderSelectionOn: html 
	self formOn: html
		with: 
			[html 
				selectFromList: self websites keys
				selected: 'Seaside'
				callback: [:v | ]
				labels: [:ea | ea asString]
				liveCallback: 
					[:item :h | 
					| url |
					url := self websites at: item.
					browser url: url.
					h spanNamed: 'selection' with: [h render: browser]]]! !

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'accessing' stamp: 'tbn 7/5/2005 10:52'!
websites
	^websites! !

!ShoreDemo1EmbeddedBrowserDemo methodsFor: 'accessing' stamp: 'tbn 7/5/2005 10:52'!
websites: anObject
	websites := anObject! !

ShoreComponent subclass: #ShoreDemo1Introduction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1Introduction methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 17:01'!
pageTitle

	^ 'Introduction' translated! !

!ShoreDemo1Introduction methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:33'!
renderContentOn: html

	html heading: 'Introduction' translated.

	html paragraph: 'Welcome to the ShoreComponets demonstration application.' translated.
	! !

ShoreComponent subclass: #ShoreDemo1NestedFormsDemo
	instanceVariableNames: 'component1 component2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1NestedFormsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 21:27'!
children

	^ { component1. component2 }.! !

!ShoreDemo1NestedFormsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 21:33'!
initialize

	super initialize.

	component1 := ShoreDemo1ComponentWithFrom parent: self.
	component2 := ShoreDemo1ComponentWithFrom2 parent: self.! !

!ShoreDemo1NestedFormsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 21:27'!
pageTitle

	^ 'Nested forms demo' translated! !

!ShoreDemo1NestedFormsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 21:52'!
renderContentOn: html

	html heading: 'Nested forms demo' translated.

	html paragraph: 'Simple component with a form:' translated.
	html render: component1.
	
	html paragraph: 'The component with a form which includes the next component with a form:' translated.
	html render: component2.
! !

ShoreComponent subclass: #ShoreDemo1RichEditDemo
	instanceVariableNames: 'editor value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1RichEditDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 17:09'!
children

	^ { editor }.! !

!ShoreDemo1RichEditDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 20:19'!
formRoot

	^ self formRootOrSelf.! !

!ShoreDemo1RichEditDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 20:16'!
initialize

	super initialize.

	editor := ShoreRichEdit parent: self.

! !

!ShoreDemo1RichEditDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 21:06'!
pageTitle

	^ 'Rich edit demo'.! !

!ShoreDemo1RichEditDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 20:36'!
renderContentOn: html

	html heading: 'Rich edit' translated.
	
	self formOn: html with: [
		html render: editor.
		html buttons: [		
			html submitButton.].
	].

	html paragraph: 'The content of the ShoreRichEdit:'.
	html html: editor content.! !

ShoreComponent subclass: #ShoreDemo1Root
	instanceVariableNames: 'panel target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1Root methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 10:30'!
children

	^ { panel. target }.! !

!ShoreDemo1Root methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:30'!
initialize

	super initialize.

	self pageTitle: 'Simple demo'.

	panel := ShoreXPPanel parent: self.
	panel addSection: (ShoreDemo1DemosMenu parent: panel) .
	panel addSection: (ShoreDemo1SimpleComponent parent: panel) .

	target := ShoreDemo1Introduction  parent: self.




	! !

!ShoreDemo1Root methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:29'!
renderContentOn: html

	html attributeAt: #height put: '100%'.
	html layoutTable: [
		html tableRow: [
			html cssClass: #leftPanel.
			html tableData: [
				html divClass: #leftPanel with: [
					html render: panel ].].
	
			html cssClass: #main.
			html attributeAt: #valign put: #top.
			html tableData: [
				html render: target] ] ].



! !

!ShoreDemo1Root methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 10:33'!
style

	^ '

.leftPanel {
	vertical-align: top;
	width: 220px;
	margin: 0px; 
	padding: 0px;
	height: 100%;
	background-color: rgb(116, 150, 226);

}

.main {
	width: 100%;
	padding: 5px;
	margin: 0px;
	margin-bottom: 0px;
	height: 100%;
	padding-bottom: 20px;
}





'! !

!ShoreDemo1Root methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 10:35'!
target

	^ target.! !

ShoreComponent subclass: #ShoreDemo1SimpleComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1SimpleComponent methodsFor: 'as yet unclassified' stamp: 'pk 6/30/2005 14:05'!
name

	^ 'Simple component'! !

!ShoreDemo1SimpleComponent methodsFor: 'as yet unclassified' stamp: 'pk 6/30/2005 14:06'!
renderContentOn: html

	html paragraph: 'This is a simple ShoreComponent' translated.

	html paragraph: 'Today: ' translated, Date today asString.! !

ShoreComponent subclass: #ShoreDemo1StandardDialogsDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Demo1'!

!ShoreDemo1StandardDialogsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:08'!
pageTitle

	^ 'Stadard dialogs demo' translated! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:08'!
renderContentOn: html

	html heading: 'Standard dialogs' translated.

	html evaluatedList: {
		[html anchorWithAction: [ self inform: 'Any message' translated ] 
		text: 'inform' translated].

		[html anchorWithAction: [ self inform: (self confirm: 'Any message' translated) ] 
			text: 'confirm' translated].

		[html anchorWithAction: [ self error: 'Any message' translated ] 
			text: 'error' translated] }..



! !

!ShoreDemo1StandardDialogsDemo methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:06'!
style

	^ '

.leftPanel {
	vertical-align: top;
	width: 220px;
	margin: 0px; 
	padding: 0px;
	height: 100%;
	background-color: rgb(116, 150, 226);

}

.layoutTable {
	width: 100%;
	height: 100%;
	padding: 0px;
}

.main {
	width: 100%;
	padding: 5px;
	margin: 0px;
	margin-bottom: 0px;
	height: 100%;
	padding-bottom: 20px;
}





'! !

ShoreComponent subclass: #ShoreEmbeddedBrowser
	instanceVariableNames: 'browserId url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-EmbeddedBrowser'!

!ShoreEmbeddedBrowser methodsFor: 'defaults' stamp: 'tbn 7/5/2005 09:56'!
defaultURL
	"Returns the receivers default URL"

	^'http://www.seaside.st'	! !

!ShoreEmbeddedBrowser methodsFor: 'initialization' stamp: 'tbn 7/5/2005 10:32'!
initialize
	"Initializes the receiver"

	super initialize.
	url := self defaultURL.
	browserId := self class newId.! !

!ShoreEmbeddedBrowser methodsFor: 'rendering' stamp: 'tbn 7/5/2005 10:40'!
renderContentOn: html
	"renders the receivers content on the given html object"
	
	html divClass: #shoreEmbeddedBrowserFrame with: [
		html 
			attributeAt: #src put: self url;
			attributeAt: #class put: #shoreEmbeddedBrowser;
			attributeAt: #id put: browserId;
			tag: #iframe.].! !

!ShoreEmbeddedBrowser methodsFor: 'accessing' stamp: 'tbn 7/5/2005 10:32'!
url
	^url! !

!ShoreEmbeddedBrowser methodsFor: 'accessing' stamp: 'tbn 7/5/2005 10:32'!
url: anObject
	url := anObject! !

ShoreComponent subclass: #ShoreFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

ShoreFormDialog subclass: #ShoreFormDialogWithResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreFormDialogWithResult methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:23'!
renderBackButtonOn: html

! !

ShoreFormDialogWithResult subclass: #ShoreInformDialog
	instanceVariableNames: 'msg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

ShoreInformDialog subclass: #ShoreConfirmDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreConfirmDialog methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:31'!
renderDialogOn: html

	html paragraph: [
		html text: self msg. ].

	html buttons: [
		html submitButtonWithAction: [ self answer: true ] text: 'Yes' translated.
		html space.
		html submitButtonWithAction: [ self answer: false ] text: 'No' translated. ]! !

!ShoreConfirmDialog methodsFor: 'accessing' stamp: 'pk 6/29/2005 21:33'!
title

	^ 'Confirmation' translated! !

ShoreInformDialog subclass: #ShoreErrorDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Dialogs'!

!ShoreErrorDialog methodsFor: 'accessing' stamp: 'pk 6/29/2005 21:35'!
title

	^ 'Error' translated .! !

!ShoreInformDialog methodsFor: 'accessing' stamp: 'pk 6/29/2005 21:25'!
msg
	^msg! !

!ShoreInformDialog methodsFor: 'accessing' stamp: 'pk 6/29/2005 21:25'!
msg: anObject
	msg := anObject! !

!ShoreInformDialog methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:25'!
renderDialogOn: html

	html paragraph: [
		html text: self msg. ].

	html buttons: [
		html submitButtonWithAction: [ self answer ] text: 'OK' translated. ]! !

!ShoreInformDialog methodsFor: 'accessing' stamp: 'pk 6/29/2005 21:32'!
title

	^ 'Information' translated .! !

!ShoreFormDialog methodsFor: 'hierarchy' stamp: 'pk 6/29/2005 22:39'!
formRoot

	^ self formRootOrSelf.! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'pk 7/3/2005 09:40'!
initialize

	super initialize.
! !

!ShoreFormDialog methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 09:45'!
pageTitle

	^ self title.! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:16'!
renderBackButtonOn: html

	html anchorWithAction: [ self answer ] text: ( '<< Back' translated  ) ! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:19'!
renderContentOn: html

	html divClass: #shoreFormDialog with: [
		html table: [
			html tableRowWith: [ 
				html divClass: #shoreBackButton with: [ self renderBackButtonOn: html ] ] 
			with: [
				html heading: self title.] ].
		self formOn: html with: [self renderDialogOn: html] ].
! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:19'!
renderDialogOn: html! !

!ShoreFormDialog methodsFor: 'rendering' stamp: 'pk 6/29/2005 21:20'!
title

	^ 'Dialog' translated.! !

ShoreComponent subclass: #ShorePageHeader
	instanceVariableNames: 'title subtitle image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Hierarchy'!

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
image
	^image! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
image: anObject
	image := anObject! !

!ShorePageHeader methodsFor: 'initialization' stamp: 'pk 7/3/2005 09:26'!
initialize

	super initialize.

	self session registerObjectForBacktracking: self.

	title := 'Title' translated.
	subtitle := 'Subtitle' translated.
	image := nil.


	! !

!ShorePageHeader methodsFor: 'initialization' stamp: 'pk 7/3/2005 09:00'!
renderContentOn: html

	image ifNotNil: [ html backgroundImage: image ].
	html divClass: #shorePageHeader with: [
	html text: title; break;
	divClass: #shorePageHeaderSubtitle with: subtitle ].

	! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
subtitle
	^subtitle! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
subtitle: anObject
	subtitle := anObject! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
title
	^title! !

!ShorePageHeader methodsFor: 'accessing' stamp: 'pk 7/2/2005 23:00'!
title: anObject
	title := anObject! !

!ShorePageHeader methodsFor: 'initialization' stamp: 'pk 7/3/2005 09:29'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: (self title, ' - ', self subtitle).

	! !

ShoreComponent subclass: #ShoreRichEdit
	instanceVariableNames: 'content rtid valueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Editors'!

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:04'!
boldImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:40'!
centreJustifyImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'style' stamp: 'pk 7/3/2005 20:22'!
editorStyle

^ '

.rte {
	font-family: sans-serif;
	font-size: 9pt;
	background-color: white;
	padding: 2px;
	margin: 2px;
}

.rte p {
	margin: 0px;
	padding: 0px;
}

.rte li {
	margin: 0px;
	padding: 0px;
}

.rte ol {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-top: 0px;
	margin-bottom: 0px;
}

.rte ul {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-top: 0px;
	margin-bottom: 0px;
}

.rte BLOCKQUOTE {
	padding-top: 0px;
	padding-bottom: 0px;
	margin-top: 0px;
	margin-bottom: 0px;
}
'! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:44'!
fullJustifyImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 19:12'!
indentImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:29'!
italicImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4286611584 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286611584 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4286611584 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286611584 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4286611584 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4286611584 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4286611584 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:35'!
leftJustifyImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 19:05'!
listImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 19:05'!
numberedListImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 19:13'!
outdentImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4278190208 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4278190208 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190208 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:39'!
rightJustifyImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 19:07'!
ruleImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4281545523 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4288256409 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit class methodsFor: 'images' stamp: 'pk 7/3/2005 18:10'!
underlineImage

	^ ShoreForm
	extent: 25@24
	depth: 32
	fromArray: #( 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4286611584 4294967295 4286611584 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4278190081 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295)
	offset: 0@0! !

!ShoreRichEdit methodsFor: 'accessing' stamp: 'pk 7/3/2005 16:55'!
content
	
	^content ifNil:['']
! !

!ShoreRichEdit methodsFor: 'accessing' stamp: 'pk 7/3/2005 16:55'!
content: anObject

	content := anObject! !

!ShoreRichEdit methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 16:55'!
formRoot

	^ self formRootOrSelf! !

!ShoreRichEdit methodsFor: 'hierarchy' stamp: 'pk 7/3/2005 20:24'!
initialize

	super initialize.
	self session registerObjectForBacktracking: self. 
	
	rtid  := self class newId.
	valueHolder := self class newId.
	
	content = String new.
	
	self formRoot addFormAttribute: (#onSubmit -> 'updateRTEs();').
! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 7/3/2005 18:28'!
renderButtonOn: html image: img id: aSymbol atl: alt action: action

	| imgPath |
	
	imgPath := 	self sessionCacheAt: aSymbol 
		ifAbsentPut: [html sessionEntryForDocument: img].

	html
		attributeAt: #alt put: alt;
		attributeAt: #src put: imgPath;
		attributeAt: #title put: alt;
		attributeAt: #onClick put: 'FormatText(''', rtid, ''', ''', action, ''', '''')';
		tag: #img.! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 7/3/2005 19:43'!
renderButtonsOn: html

	html divClass: #shoreRichEditButtons with: [
		self renderButtonOn: html image: (self class boldImage) id: #ShoreRichEditBoldImage 
			atl: 'bold' translated action: 'bold'.
		self renderButtonOn: html image: (self class italicImage) id: #ShoreRichEditItalicImage 
			atl: 'italic' translated action: 'italic'.
		self renderButtonOn: html image: (self class underlineImage) id: #ShoreRichEditUnderlineImage 
			atl: 'underline' translated action: 'underline'.
		
		self separatorOn: html.

		self renderButtonOn: html image: (self class leftJustifyImage ) id: #ShoreRichEditLeftJustifyImage 
			atl: 'left' translated action: 'justifyleft'.
		self renderButtonOn: html image: (self class centreJustifyImage ) id: #ShoreRichEditCentreJustifyImage 
			atl: 'centre' translated action: 'justifycenter'.
		self renderButtonOn: html image: (self class rightJustifyImage ) id: #ShoreRichEditRightJustifyImage 
			atl: 'right' translated action: 'justifyright'.
		self renderButtonOn: html image: (self class fullJustifyImage ) id: #ShoreRichEditFullJustifyImage 
			atl: 'full' translated action: 'justifyfull'.

		self separatorOn: html.

		self renderButtonOn: html image: (self class ruleImage ) id: #ShoreRichEditRulerImage 
			atl: 'horizontal rule' translated action: 'inserthorizontalrule'.

		self separatorOn: html.

		self renderButtonOn: html image: (self class numberedListImage ) id: #ShoreRichEditNumberedListImage 
			atl: 'numbered list' translated action: 'insertorderedlist'.
		self renderButtonOn: html image: (self class listImage ) id: #ShoreRichEditListImage 
			atl: 'list' translated action: 'insertunorderedlist'.

		self separatorOn: html.

		self renderButtonOn: html image: (self class outdentImage ) id: #ShoreRichEditOutdentImage 
			atl: 'outdent' translated action: 'outdent'.
		self renderButtonOn: html image: (self class indentImage ) id: #ShoreRichEditIndentImage 
			atl: 'indent' translated action: 'indent'.
	]


! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 7/3/2005 19:26'!
renderContentOn: html

	| style |

	self formOn: html with: [
		html  divClass: #shoreRichEdit with: [
			html 
				attributeAt: #id put: valueHolder; 
				hiddenInputWithValue: self content callback: [:val | self content: val].

			self renderButtonsOn: html.
			self renderIFrameOn: html.

			style := 	self sessionCacheAt: #ShoreRichEditStyle 
				ifAbsentPut: [html sessionEntryForDocument: self class editorStyle].

			html html: '<script language="JavaScript" type="text/javascript">
				initRTE("', style, '");
				registerRTE(''', rtid, ''', ''', valueHolder ,''');
				enableDesignMode(''', rtid, ''', false, ''', valueHolder ,''');
				</script>'.
		].
	].





! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 7/3/2005 20:14'!
renderIFrameOn: html

	html divClass: #shoreRichEditField with: [
		html 
			attributeAt: #class put: #shoreRichEditEditor;
			attributeAt: #scrolling put: #yes;
			attributeAt: #frameBorder put: 0;
			attributeAt: #id put: rtid;
			attributeAt: #name put: rtid;
			tag: #iframe.].! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 7/3/2005 16:58'!
script 

	^ 
'// Cross-Browser Rich Text Editor
// http://www.kevinroth.com/rte/demo.htm
// Written by Kevin Roth (kevin@NOSPAMkevinroth.com - remove NOSPAM)
// Visit the support forums at http://www.kevinroth.com/forums/index.php?c=2

//init variables
var rng;
var currentRTE;
var allRTEs = "";
var allValueHolders = "";

var isGecko;
var isSafari;
var isKonqueror;

var cssFile;


function initRTE(css) {
	//set browser vars
	var ua = navigator.userAgent.toLowerCase();
	isGecko = (ua.indexOf("gecko") !!= -1);
	isSafari = (ua.indexOf("safari") !!= -1);
	isKonqueror = (ua.indexOf("konqueror") !!= -1);
	
	//set paths vars
	cssFile = css;
	
}

function registerRTE(rte, valueHolder) {
		if (allRTEs.length > 0) allRTEs += ";";
		if (allRTEs.length > 0) allValueHolders += ";";
		allRTEs += rte;
		allValueHolders += valueHolder;
}

function enableDesignMode(rte, readOnly, valueHolder) 
{
	var html = document.getElementById(valueHolder).value;
	
		var frameHtml = "<html id=\"" + rte + "\">\n";
	frameHtml += "<head>\n";
	//to reference your stylesheet, set href property below to your stylesheet path and uncomment
	if (cssFile.length > 0) {
		frameHtml += "<link media=\"all\" type=\"text/css\" href=\"" + cssFile + "\" rel=\"stylesheet\">\n";
	} else {
		frameHtml += "<style>\n";
		frameHtml += "body {\n";
		frameHtml += "	background: #FFFFFF;\n";
		frameHtml += "	margin: 0px;\n";
		frameHtml += "	padding: 0px;\n";
		frameHtml += "}\n";
		frameHtml += "</style>\n";
	}
	frameHtml += "</head>\n";
	frameHtml += "<body class=rte>\n";
	frameHtml +=  html + "\n";
	frameHtml += "</body>\n";
	frameHtml += "</html>";
	
	if (document.all) {
		var oRTE = frames[rte].document;
		oRTE.open();
		oRTE.write(frameHtml);
		oRTE.close();
		if (!!readOnly) oRTE.designMode = "On";
	} else {
		try {
			if (!!readOnly) document.getElementById(rte).contentDocument.designMode = "on";
			try {
				var oRTE = document.getElementById(rte).contentWindow.document;
				oRTE.open();
				oRTE.write(frameHtml);
				oRTE.close();
				if (isGecko && !!readOnly) {
					//attach a keyboard handler for gecko browsers to make keyboard shortcuts work
					oRTE.addEventListener("keypress", kb_handler, true);
				}
			} catch (e) {
				alert("Error preloading content.");
			}
		} catch (e) {
			//gecko may take some time to enable design mode.
			//Keep looping until able to set.
			if (isGecko) {
				var expr = "enableDesignMode(''" + rte + "'', " + readOnly + ", ''" + valueHolder + "'');";
				setTimeout(expr, 10);
			} else {
				return false;
			}
		}
	}
}

function updateRTEs() {
	var vRTEs = allRTEs.split(";");
	var vValueHolders = allValueHolders.split(";");
	for (var i = 0; i < vRTEs.length; i++) {
		updateRTE(vRTEs[i], vValueHolders[i]);
	}
}

function updateRTE(rte, valueHolder) 
{

	//set message value
	var oHdnMessage = document.getElementById(valueHolder);
	var oRTE = document.getElementById(rte);
	var readOnly = false;
	
	//check for readOnly mode
	if (document.all) {
		if (frames[rte].document.designMode !!= "On") readOnly = true;
	} else {
		if (document.getElementById(rte).contentDocument.designMode !!= "on") readOnly = true;
	}
	
	//if viewing source, switch back to design view
	
	if (oHdnMessage.value == null) oHdnMessage.value = "";
	if (document.all) {
		oHdnMessage.value = frames[rte].document.body.innerHTML;
	} else {
		oHdnMessage.value = oRTE.contentWindow.document.body.innerHTML;
	}
	
	//if there is no content (other than formatting) set value to nothing
	if (stripHTML(oHdnMessage.value.replace("&nbsp;", " ")) == "" 
		&& oHdnMessage.value.toLowerCase().search("<hr") == -1
		&& oHdnMessage.value.toLowerCase().search("<img") == -1) oHdnMessage.value = "";
	//fix for gecko
	if (escape(oHdnMessage.value) == "%3Cbr%3E%0D%0A%0D%0A%0D%0A") oHdnMessage.value = "";
	
}

//Function to format text in the text box
function FormatText(rte, command, option) {
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		
		//get current selected range
		var selection = oRTE.document.selection; 
		if (selection !!= null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	try {
			oRTE.focus();
		  	oRTE.document.execCommand(command, false, option);
			oRTE.focus();
	} catch (e) {
		alert(e);
	}
}

function Select(rte, selectname) {
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		
		//get current selected range
		var selection = oRTE.document.selection; 
		if (selection !!= null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	var idx = document.getElementById(selectname).selectedIndex;
	// First one is always a label
	if (idx !!= 0) {
		var selected = document.getElementById(selectname).options[idx].value;
		var cmd = selectname.replace(''_'' + rte, '''');
		oRTE.focus();
		oRTE.document.execCommand(cmd, false, selected);
		oRTE.focus();
		document.getElementById(selectname).selectedIndex = 0;
	}
}

function Replace(rte, text) {
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		
		//get current selected range
		var selection = oRTE.document.selection; 
		if (selection !!= null) {
			rng = selection.createRange();
		}
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		
		//get currently selected range
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
	
	var idx = document.getElementById(selectname).selectedIndex;
	// First one is always a label
	if (idx !!= 0) {
		var selected = text;
		var cmd = selectname.replace(''_'' + rte, '''');
		oRTE.focus();
		oRTE.document.execCommand(cmd, false, selected);
		oRTE.focus();
		document.getElementById(selectname).selectedIndex = 0;
	}
}

function kb_handler(evt) {
	var rte = evt.target.id;
	
	//contributed by Anti Veeranna (thanks Anti!!)
	if (evt.ctrlKey) {
		var key = String.fromCharCode(evt.charCode).toLowerCase();
		var cmd = '''';
		switch (key) {
			case ''b'': cmd = "bold"; break;
			case ''i'': cmd = "italic"; break;
			case ''u'': cmd = "underline"; break;
		};

		if (cmd) {
			FormatText(rte, cmd, true);
			//evt.target.ownerDocument.execCommand(cmd, false, true);
			// stop the event bubble
			evt.preventDefault();
			evt.stopPropagation();
		}
 	}
}


function stripHTML(oldString) {
	var newString = oldString.replace(/(<([^>]+)>)/ig,"");
	
	//replace carriage returns and line feeds
   newString = newString.replace(/\r\n/g," ");
   newString = newString.replace(/\n/g," ");
   newString = newString.replace(/\r/g," ");
	
	//trim string
	newString = trim(newString);
	
	return newString;
}

function trim(inputString) {
   // Removes leading and trailing spaces from the passed string. Also removes
   // consecutive spaces and replaces it with one space. If something besides
   // a string is passed in (null, custom object, etc.) then return the input.
   if (typeof inputString !!= "string") return inputString;
   var retValue = inputString;
   var ch = retValue.substring(0, 1);
	
   while (ch == " ") { // Check for spaces at the beginning of the string
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length - 1, retValue.length);
	
   while (ch == " ") { // Check for spaces at the end of the string
      retValue = retValue.substring(0, retValue.length - 1);
      ch = retValue.substring(retValue.length - 1, retValue.length);
   }
	
	// Note that there are two spaces in the string - look for multiple spaces within the string
   while (retValue.indexOf("  ") !!= -1) {
		// Again, there are two spaces in each of the strings
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ") + 1, retValue.length);
   }
   return retValue; // Return the trimmed string back to the user
}

'! !

!ShoreRichEdit methodsFor: 'rendering' stamp: 'pk 7/3/2005 19:14'!
separatorOn: html

	html space; space.! !

ShoreComponent subclass: #ShoreTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreTask methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2005 21:07'!
decoration: oldDecoration shouldWrap: newDecoration

	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!ShoreTask methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2005 21:08'!
go

	self subclassResponsibility! !

!ShoreTask methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2005 21:07'!
renderContentOn: html

	self session redirectTo: (html urlForAction: [[self answer: self go] repeat])! !

ShoreComponent subclass: #ShoreXPPanel
	instanceVariableNames: 'sections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-XPPanel'!

!ShoreXPPanel methodsFor: 'sections' stamp: 'pk 6/30/2005 12:59'!
addSection: aComponent

	aComponent addDecoration: ShoreXPPanelDecoration new.
	sections add: aComponent.
! !

!ShoreXPPanel methodsFor: 'accessing' stamp: 'pk 6/30/2005 11:20'!
children

	^ sections! !

!ShoreXPPanel methodsFor: 'initialization' stamp: 'pk 7/3/2005 22:31'!
initialize

	super initialize.
	self session registerObjectForBacktracking: self. 
	
	sections := OrderedCollection new.! !

!ShoreXPPanel methodsFor: 'rendering' stamp: 'pk 6/30/2005 20:18'!
renderContentOn: html

	html cssClass: 'shoreXPPanel'.
	"html attributeAt: #height put:  '100%'."
		
	html div: [
		sections do: [ :section |
			html render: section] ] . 
! !

WAHtmlRenderer subclass: #ShoreRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreRenderer methodsFor: 'convenience' stamp: 'pk 7/6/2005 13:47'!
backgroundImage: path

	self attributeAt: #style put: ('background-image: url(', path, ')').! !

!ShoreRenderer methodsFor: 'convenience' stamp: 'pk 6/29/2005 21:26'!
buttons: aBlock

	self divClass: #shoreButtons with: aBlock ! !

!ShoreRenderer methodsFor: 'lists' stamp: 'pk 6/29/2005 22:44'!
evaluatedList: aCollection

	self list: aCollection do: [:item | item value ].! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:18'!
rectangle: rect align: align class: cssClass

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div class="{1} style="width: {2}; height: {3}; left: {4}; top: {5}; position: {6};"></div>'
	format: {
		cssClass asString.
		rect width asString, 'px'.
		rect height asString, 'px'.
		rect left asString, 'px'.
		rect top asString, 'px'.
		align asString.
	})  .


	! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:18'!
rectangle: rect align: align color: bgColor borderWidth: borderWidth borderColor: borderColor borderStyle: borderStyle for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div style="
	width: {1};
	height: {2};
	left: {3}; 
	top: {4}; 
	background-color: {5}; 	
	border-color: {6};
	position: {7};
	border-width: {8};
	border-style: {9};
	font-size: 8pt;
">'
	format: {
		rect width asString, 'px'.
		rect height asString, 'px'.
		rect left asString, 'px'.
		rect top asString, 'px'.
		bgColor ifNotNil: [bgColor asHTMLColor asString] ifNil: ['none'].
		borderColor asHTMLColor asString.
		align asString.
		borderWidth asString, 'px'.
		borderStyle asString.

	})  .

	aBlock value.
	
	self html: '</div>'.

	! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:18'!
rectangle: rect align: align color: bgColor borderWidth: borderWidth borderColor: borderColor for: aBlock

	^ self rectangle: rect align: align color: bgColor borderWidth: borderWidth borderColor: borderColor borderStyle: 'solid' for: aBlock! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:18'!
rectangle: rect class: cssClass

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div class="{1}" style="width: {2}; height: {3}; left: {4}; top: {5};"></div>'
	format: {
		cssClass asString.
		rect width asString, 'px'.
		rect height asString, 'px'.
		rect left asString, 'px'.
		rect top asString, 'px'.
	})  .


	! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:18'!
rectangle: rect class: cssClass color: color for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div onClick="submit()" class="{1}" style="width: {2}; height: {3}; left: {4}; top: {5}; background-color: {6}">'
	format: {
		cssClass asString.
		rect width asString, 'px'.
		rect height asString, 'px'.
		rect left asString, 'px'.
		rect top asString, 'px'.
		color ifNotNil: [color asHTMLColor asString] ifNil: ['none'].
	}) .

	aBlock value.
	
	self html: '</div>'.


	! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 19:32'!
rectangle: rect class: cssClass color: color onClick: script1 onMouseOver: script2 onMouseOut: script3 for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div onClick="{1}" onMouseOver="{2}" onMouseOut="{3}" class="{4}" style="width: {5}; height: {6}; left: {7}; top: {8}; background-color: {9}">'
	format: {
		script1 asString.
		script2 asString.
		script3 asString.
		cssClass asString.
		rect width asString, 'px'.
		rect height asString, 'px'.
		rect left asString, 'px'.
		rect top asString, 'px'.
		color isString
			ifTrue: [ color ]
			ifFalse: [color ifNotNil: [color asHTMLColor asString] ifNil: ['none']].
	}) .

	aBlock value.
	
	self html: '</div>'.


	! !

!ShoreRenderer methodsFor: 'rectangles' stamp: 'pk 7/6/2005 08:19'!
rectangle: rect class: cssClass for: aBlock

	" align: #absolute, #relative, #fixed ..."

	self html: 
	('<div class="{1}" style="width: {2}; height: {3}; left: {4}; top: {5};">'
	format: {
		cssClass asString.
		rect width asString, 'px'.
		rect height asString, 'px'.
		rect left asString, 'px'.
		rect top asString, 'px'.
	}) .

	aBlock value.
	
	self html: '</div>'.


	! !

!ShoreRenderer methodsFor: 'tables' stamp: 'pk 6/30/2005 12:21'!
rowLayout: cells

	| cellWidth |
	
	cellWidth := 100 / cells size.

	self attributes width: '100%'.
	self table: [
		self attributeAt: #height put:  '100%'.
		self tableRow: [
			cells do: [:cell | 
				self attributes width: cellWidth asString, '%'.
				self tableData: cell ] ] ].! !

!ShoreRenderer methodsFor: 'convenience' stamp: 'pk 6/29/2005 21:28'!
separator

	self space; text: '|'; space.! !

!ShoreRenderer methodsFor: 'caching' stamp: 'pk 7/3/2005 15:45'!
sessionEntryForDocument: document

	^ ShoreSessionEntry url: (self context urlForDocument: document) document: document! !

Object subclass: #ShoreDayTimetableItem
	instanceVariableNames: 'id interval color text column action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Timetables'!

!ShoreDayTimetableItem class methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 18:03'!
from: start to: end column: column text: text color: color

	| item |

	item := self new.
	item interval: (start to: end).
	item column: column.
	item text: text.
	item color: color.

	^ item.! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 19:36'!
action
	^action! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 19:36'!
action: anObject
	action := anObject! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:53'!
color
	^color! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:53'!
color: anObject
	color := anObject! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 18:03'!
column
	^column! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 18:03'!
column: anObject
	column := anObject! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:57'!
id
	^id! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:57'!
id: anObject
	id := anObject! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 19:37'!
initilalize

	super initialize.
	id := ShoreComponent newId.
	action := String new.! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:53'!
interval
	^interval! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:53'!
interval: anObject
	interval := anObject! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:54'!
text
	^text! !

!ShoreDayTimetableItem methodsFor: 'accessing' stamp: 'pk 7/6/2005 17:54'!
text: anObject
	text := anObject! !

Object subclass: #ShoreSessionEntry
	instanceVariableNames: 'url document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreSessionEntry class methodsFor: 'instance creation' stamp: 'pk 7/3/2005 20:57'!
url: url document: doc

	| entry |

	entry := self new.
	entry url: url.
	entry document: doc asMIMEDocument.
	^ entry.! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 7/3/2005 15:24'!
document
	"Answer the value of document"

	^ document! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 7/3/2005 15:24'!
document: anObject
	"Set the value of document"

	document _ anObject! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 7/3/2005 15:24'!
url
	"Answer the value of url"

	^ url! !

!ShoreSessionEntry methodsFor: 'accessing' stamp: 'pk 7/3/2005 15:24'!
url: anObject
	"Set the value of url"

	url _ anObject! !

WAStyleLibrary subclass: #ShoreStandardStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Libraries'!

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 20:32'!
body

^ '
body {
	margin: 0px; 
	font-family: sans-serif; 
	font-size: 9pt;
}

img{
	border-style: none ;
}

h1 {
	font-size: 200%;	
}

ul { 
	margin-left: 10px;
	padding-left: 10px;
}



'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 11:39'!
dialogs

^ '

.shoreFormDialog {
	border: 2px solid #3d64bc;;
	background-color: #ecf1fd;
	margin-left: 10%;
	margin-right: 10%; 
	margin-top: 5px; 
	padding: 5px;
}

.shoreFormDialog h1 {
	font-size: 120%;
	font-weight: bold;
	margin: 0px;
}

.shoreFormDialog p {
	border: 1px solid #e0e0e7;
	text-align: center;
	padding: 1px;
	margin: 1px;
	margin-left: 5%;
	margin-right: 5%;
	background-color: rgb(247, 249, 254);
}

.shoreButtons {
	text-align: center;
	margin: 3px;
}

.shoreBackButton {
	font-size: 9pt;
	font-weight: bold;
	text-decoration: none;
	margin-right: 10px; 
}

.shoreBackButton a {
	text-decoration: none;
}


'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 20:14'!
editors

^ '
.shoreRichEdit {
	border: 1px solid #8e98b5;
}

.shoreRichEditField {
	border: 1px solid #8e98b5;
	margin: 3px;
}

.shoreRichEditEditor {
	width: 100%;
}

.shoreRichEditButtons {

}
'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'tbn 7/5/2005 10:43'!
embeddedBrowser
	"Returns the style information for the embedded browser" 

^'

.shoreEmbeddedBrowserFrame {
	width:95%;
	height:400px
}

.shoreEmbeddedBrowser {
	width:100%;
	height:100%
}'
! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/3/2005 08:52'!
hierarchy

^ '
.shorePageHeader {
	color: white;
	margin: 0px; 
	padding: 0px;
	padding-left: 40px;
	border: 0px;
	font: 16pt sans-serif;
	font-weight: bold;
	height: 45px;
	background-color: #3d64bc;
	background-repeat: no-repeat;
	background-position: 4px;
}

.shorePageHeader img {
	float: left;
	border: 0px;
	padding-right: 50px;
}

.shorePageHeaderSubtitle {
	font: 9pt sans-serif;
	font-weight: bold;
}

'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/2/2005 22:48'!
lists

^ '
.shoreBatchedList {
	background-color: #ecf1fd;
	border: 1px solid #8e98b5;
	margin-left: 5%;
	margin-right: 5%;
}

.shoreBatchedListNavigation {
	background-color: #c6d3f7;
	font-weight: bold;
	padding: 3px;
	padding-left: 10px;
}

.shoreBatchedListNavigation a {
	text-decoration: none;
}

.shoreBatchedListSorters {
	font-weight: normal;
	padding-left: 10px;
	float: right;
}

.shoreBatchedListItem{
	/* width:  60px; */
	/*float: left;*/
	float: left;
	padding-left: 5px;
}

.shoreBatchedListItemNote {
	padding-right: 5px;
	padding-right: 5px;
	color: gray;
	float: right;
}
'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 19:30'!
timetables

^ '
.shoreDayTimetable {
	border: 2px solid black;
	position: relative;

}

.shoreDayTimetableItem {
	position: absolute;
	border-width: 0px;
	font-size: 8pt;
}
'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 6/29/2005 21:54'!
useful

^ '

.renderingTime {
	text-align: right;
	color: lightGray;
}

'! !

!ShoreStandardStyles methodsFor: 'as yet unclassified' stamp: 'pk 7/1/2005 08:07'!
xpPanel

^ '
.shoreXPPanel {

	padding:10px;

	height: 100%;	
	background-color: rgb(116, 150, 226);

}

.shoreXPPanelSectionsTable {
	padding: 0px;
	margin-top: 8px;
	margin-bottom: 8px;
	width: 100%;
}

.shoreXPPanelTopLeft {
	background-color: rgb(247, 249, 254);
	height: 25px;
	width: 2px;
	cursor: pointer;
	background-position: left top;
	background-repeat: no-repeat;
}

.shoreXPPanelTopRightOpen {
	background-color: rgb(247, 249, 254);
	color: rgb(33, 93, 198);
	cursor: pointer;
	height: 20px;
	font-weight: bold;
	font-size: 11px;
	font-family: verdana,tahoma,arial,sans-serif;
	padding-left: 10px;
	padding-right: 35px;
	background-position: right top;
	background-repeat: no-repeat;
}
.shoreXPPanelTopRightClosed {
	background-color: rgb(247, 249, 254);
	color: rgb(33, 93, 198);
	cursor: pointer;
	height: 20px;
	font-weight: bold;
	font-size: 11px;
	font-family: verdana,tahoma,arial,sans-serif;
	padding-left: 10px;
	padding-right: 35px;
	background-position: right top;
	background-repeat: no-repeat;
}
.shoreXPPanelSection {
	border-left: 1px solid rgb(247, 249, 254);
	border-right: 1px solid rgb(247, 249, 254);
	border-bottom: 1px solid rgb(247, 249, 254);
	background-color: rgb(214, 223, 247);
	font-family: verdana,tahoma,arial,sans-serif;
	color: black;
	cursor: default;
	font-size: 10px;
	padding: 5px;
}

.shoreXPPanelHiddenSection{
	display: none;
}


'! !

WADecoration subclass: #ShoreDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Kernel'!

!ShoreDecoration methodsFor: 'renderer' stamp: 'pk 6/29/2005 21:11'!
rendererClass 

	^ ShoreRenderer! !

ShoreDecoration subclass: #ShoreXPPanelDecoration
	instanceVariableNames: 'sections width open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-XPPanel'!

!ShoreXPPanelDecoration class methodsFor: 'images' stamp: 'pk 6/30/2005 12:27'!
topLeftImage

	^  ShoreForm
	extent: 2@2
	depth: 32
	fromArray: #( 4285698785 4285698785 4285698784 4294967295)
	offset: 0@0! !

!ShoreXPPanelDecoration class methodsFor: 'images' stamp: 'pk 6/30/2005 12:28'!
topRightClosedImage
^ ShoreForm
	extent: 88@25
	depth: 32
	fromArray: #( 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291614968 4291614968 4291549176 4291549176 4291483384 4291483384 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4285830626 4285830626 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291614968 4291614968 4291549176 4291549176 4291483384 4291483384 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4285830626 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291548920 4291483382 4291483125 4291351540 4291351796 4291351796 4291285749 4291417590 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291614712 4291483125 4290890476 4290298594 4290100446 4289968860 4290100445 4290100444 4289837787 4290035167 4290561768 4291220212 4291351798 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291482611 4290364131 4289837528 4290955231 4292467947 4293191665 4293717749 4293520372 4292731117 4291218401 4289639380 4289771996 4290759405 4291220469 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291417331 4290298337 4289902807 4292336362 4294375418 4294967295 4294967295 4294967295 4294967295 4294967295 4294835710 4293257201 4290494683 4289508567 4290562283 4291220213 4291286262 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291746294 4290693095 4289903064 4292467947 4294835710 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293980663 4290560732 4289574616 4290825456 4291220213 4291286006 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291351281 4289903579 4291613157 4294704381 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293586164 4289771221 4290035682 4291022834 4291220213 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4290956524 4290100442 4293520372 4294967295 4294967295 4278205605 4278205605 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4294901503 4294835966 4291612900 4289574617 4290628334 4291154420 4291220470 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290758888 4290823645 4294572796 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4278205605 4278205605 4294967295 4294967295 4294901503 4294704381 4292994544 4289574614 4290299625 4291022578 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290627560 4291283938 4294967295 4294967295 4294967295 4294967295 4294967295 4278205605 4278205605 4278205605 4294967295 4294967295 4294967295 4294835966 4294573053 4293455092 4289837528 4290036455 4290825457 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290627303 4291218401 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278205605 4294967295 4294967295 4294967295 4294967295 4294770174 4294507260 4293520884 4289968857 4289970662 4290759663 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290627559 4290692317 4294704381 4294967295 4294967295 4278205605 4278205605 4294967295 4294967295 4294967295 4278205605 4278205605 4294901503 4294704381 4294310139 4293192178 4289837528 4289904869 4290693870 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290890987 4289903063 4293783285 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4278205605 4278205605 4294967295 4294835966 4294507260 4294113018 4292468460 4289640151 4290036199 4290693870 4291023348 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4291154160 4289574359 4291744486 4294835711 4294901503 4294901503 4294967295 4278205605 4278205605 4278205605 4294967295 4294835966 4294573053 4294178554 4293652726 4291021280 4289377495 4290036455 4290693870 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4291483124 4290232546 4289771220 4292928495 4294704381 4294704381 4294704381 4294835966 4278205605 4294835966 4294704381 4294441468 4294113018 4293784312 4292139497 4289705685 4289509597 4290036713 4290759663 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291614709 4290956783 4289640410 4289968599 4292731374 4294375931 4294310139 4294375931 4294375931 4294310139 4294178554 4293915640 4293718263 4292139754 4290034648 4289245911 4289707491 4290299628 4290825457 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291680502 4291351282 4290627817 4289509336 4289771222 4291810535 4293323764 4293849848 4293850104 4293784312 4293652470 4292994801 4291547621 4289968598 4289376983 4289510368 4290036199 4290497005 4291022578 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291746295 4291548917 4291154160 4290496745 4289575131 4289311443 4290100440 4290823903 4291152865 4291152865 4290823903 4290034649 4289442517 4289312217 4289510112 4289905126 4290299628 4290759919 4291154420 4291220470 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291614710 4291417332 4291023088 4290496747 4290035939 4289706974 4289575388 4289443804 4289443804 4289443804 4289443804 4289575647 4289641699 4290035942 4290299370 4290694126 4291023091 4291220213 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291614710 4291351796 4291088368 4290693868 4290430954 4290167783 4290101991 4290036454 4289970662 4290036455 4290101734 4290233577 4290496492 4290759919 4291023091 4291220469 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291549174 4291417589 4291154161 4290957039 4290759661 4290628590 4290628076 4290562284 4290628334 4290628333 4290759662 4290956784 4291089140 4291220469 4291286262 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291614711 4291483126 4291352053 4291286004 4291154419 4291154162 4291088370 4291088627 4291154419 4291154676 4291285749 4291286262 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291549175 4291549175 4291483383 4291417590 4291351798 4291417591 4291417590 4291351798 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291614968 4291614968 4291549176 4291549176 4291483384 4291483384 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471)
	offset: 0@0! !

!ShoreXPPanelDecoration class methodsFor: 'images' stamp: 'pk 6/30/2005 12:28'!
topRightOpenImage
^ ShoreForm
	extent: 88@25
	depth: 32
	fromArray: #( 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291614968 4291614968 4291549176 4291549176 4291483384 4291483384 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4285698785 4285698785 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291614968 4291614968 4291549176 4291549176 4291483384 4291483384 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4285698784 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291548920 4291483382 4291483125 4291351540 4291351796 4291351796 4291285749 4291417590 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291614712 4291483125 4290890476 4290298594 4290100446 4289968860 4290100445 4290100444 4289837787 4290035167 4290561768 4291220212 4291351798 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291482611 4290364131 4289837528 4290955231 4292467947 4293191665 4293717749 4293520372 4292731117 4291218401 4289639380 4289771996 4290759405 4291220469 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291417331 4290298337 4289902807 4292336362 4294375418 4294967295 4294967295 4294967295 4294967295 4294967295 4294835710 4293257201 4290494683 4289508567 4290562283 4291220213 4291286262 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291746294 4290693095 4289903064 4292467947 4294835710 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4293980663 4290560732 4289574616 4290825456 4291220213 4291286006 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291351281 4289903579 4291613157 4294704381 4294967295 4294967295 4294967295 4294967295 4278205605 4294967295 4294967295 4294967295 4294967295 4294967295 4293586164 4289771221 4290035682 4291022834 4291220213 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4290956524 4290100442 4293520372 4294967295 4294967295 4294967295 4294967295 4278205605 4278205605 4278205605 4294967295 4294967295 4294967295 4294901503 4294835966 4291612900 4289574617 4290628334 4291154420 4291220470 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290758888 4290823645 4294572796 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4278205605 4278205605 4294967295 4294967295 4294901503 4294704381 4292994544 4289574614 4290299625 4291022578 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290627560 4291283938 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4294835966 4294573053 4293455092 4289837528 4290036455 4290825457 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290627303 4291218401 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278205605 4294967295 4294967295 4294967295 4294967295 4294770174 4294507260 4293520884 4289968857 4289970662 4290759663 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290627559 4290692317 4294704381 4294967295 4294967295 4294967295 4294967295 4278205605 4278205605 4278205605 4294967295 4294967295 4294901503 4294704381 4294310139 4293192178 4289837528 4289904869 4290693870 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4290890987 4289903063 4293783285 4294967295 4294967295 4294967295 4278205605 4278205605 4294967295 4278205605 4278205605 4294967295 4294835966 4294507260 4294113018 4292468460 4289640151 4290036199 4290693870 4291023348 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4291154160 4289574359 4291744486 4294835711 4294901503 4278205605 4278205605 4294967295 4294967295 4294967295 4278205605 4278205605 4294573053 4294178554 4293652726 4291021280 4289377495 4290036455 4290693870 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291811831 4291483124 4290232546 4289771220 4292928495 4294704381 4294704381 4294704381 4294835966 4294835966 4294835966 4294704381 4294441468 4294113018 4293784312 4292139497 4289705685 4289509597 4290036713 4290759663 4291088884 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291614709 4290956783 4289640410 4289968599 4292731374 4294375931 4294310139 4294375931 4294375931 4294310139 4294178554 4293915640 4293718263 4292139754 4290034648 4289245911 4289707491 4290299628 4290825457 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291680502 4291351282 4290627817 4289509336 4289771222 4291810535 4293323764 4293849848 4293850104 4293784312 4293652470 4292994801 4291547621 4289968598 4289376983 4289510368 4290036199 4290497005 4291022578 4291154677 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291746295 4291548917 4291154160 4290496745 4289575131 4289311443 4290100440 4290823903 4291152865 4291152865 4290823903 4290034649 4289442517 4289312217 4289510112 4289905126 4290299628 4290759919 4291154420 4291220470 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291614710 4291417332 4291023088 4290496747 4290035939 4289706974 4289575388 4289443804 4289443804 4289443804 4289443804 4289575647 4289641699 4290035942 4290299370 4290694126 4291023091 4291220213 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291614710 4291351796 4291088368 4290693868 4290430954 4290167783 4290101991 4290036454 4289970662 4290036455 4290101734 4290233577 4290496492 4290759919 4291023091 4291220469 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291549174 4291417589 4291154161 4290957039 4290759661 4290628590 4290628076 4290562284 4290628334 4290628333 4290759662 4290956784 4291089140 4291220469 4291286262 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291614711 4291483126 4291352053 4291286004 4291154419 4291154162 4291088370 4291088627 4291154419 4291154676 4291285749 4291286262 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291549175 4291549175 4291483383 4291417590 4291351798 4291417591 4291417590 4291351798 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471 4294309886 4294244349 4294244093 4294178557 4294112765 4294112765 4294046973 4294046973 4294046973 4293981181 4293915645 4293915389 4293849853 4293784061 4293784060 4293718268 4293718268 4293652732 4293652476 4293586940 4293521148 4293521148 4293455356 4293389820 4293389564 4293324027 4293324027 4293258235 4293192699 4293192443 4293126651 4293061115 4293060859 4292995323 4292929531 4292929531 4292929531 4292863738 4292798202 4292797946 4292732410 4292666618 4292601082 4292600826 4292600826 4292535290 4292469498 4292469498 4292403706 4292338169 4292337913 4292272377 4292272121 4292206585 4292206585 4292140793 4292140793 4292075001 4292009465 4292009209 4291943673 4291943416 4291877880 4291877880 4291877624 4291812088 4291746296 4291746296 4291680760 4291680504 4291614968 4291614968 4291614968 4291549176 4291549176 4291483384 4291483384 4291483383 4291417591 4291417591 4291352055 4291352055 4291352055 4291351799 4291286263 4291286263 4291286007 4291220471)
	offset: 0@0! !

!ShoreXPPanelDecoration methodsFor: 'initialization' stamp: 'pk 6/30/2005 13:51'!
initialize

	super initialize.
	
	open := true.! !

!ShoreXPPanelDecoration methodsFor: 'accessing' stamp: 'pk 6/30/2005 13:01'!
open
	^open! !

!ShoreXPPanelDecoration methodsFor: 'accessing' stamp: 'pk 6/30/2005 13:01'!
open: anObject
	open := anObject! !

!ShoreXPPanelDecoration methodsFor: 'rendering' stamp: 'pk 7/3/2005 16:17'!
renderContentOn: html

	| topLeftImage topRightOpenImage topRightClosedImage |
	
	topLeftImage := self owner sessionCacheAt: #ShoreXPPanelDecorationTopLeftImage 
		ifAbsentPut: [ html sessionEntryForDocument: (self class topLeftImage) ].
	topRightOpenImage := self owner sessionCacheAt: #ShoreXPPanelDecorationTopRightOpenImage 
		ifAbsentPut: [ html sessionEntryForDocument: (self class topRightOpenImage) ].
	topRightClosedImage := self  owner sessionCacheAt: #ShoreXPPanelDecorationTopRightClosedImage
		ifAbsentPut: [ html sessionEntryForDocument: (self class topRightClosedImage) ].

	html cssClass: #shoreXPPanelSectionsTable.
	html attributeAt: #border put: '0';
		attributeAt: #cellPadding put: '0';
		attributeAt: #cellSpacing put: '0'.
	html table: [
		| id |
		id := html self context advanceKey.
		html attributeAt: #onClick put: '
		if (cells[1].className == ''shoreXPPanelTopRightClosed'') {
			parentNode.rows[1].cells[0].className = ''shoreXPPanelSection'';
			cells[1].style.backgroundImage="url(', topRightOpenImage, ')";
			cells[1].className = ''shoreXPPanelTopRightOpen'';
		} else {
			parentNode.rows[1].cells[0].className = ''shoreXPPanelHiddenSection'';
			cells[1].style.backgroundImage="url(', topRightClosedImage, ')";
			cells[1].className = ''shoreXPPanelTopRightClosed'';
	}'.
		html tableRow: [
			html cssClass: #shoreXPPanelTopLeft;
				attributeAt: #background put: topLeftImage;
				tableData: [html space].
			html cssClass: (self open
					ifTrue: [ #shoreXPPanelTopRightOpen ]
					ifFalse: [ #shoreXPPanelTopRightClosed ]).
			self open
				ifTrue: [ html attributeAt: #background put: topRightOpenImage ]
				ifFalse: [ html attributeAt: #background put: topRightClosedImage ].
			
			html tableData: (self owner name)
		].
		html cssId: id.
		html tableRow: [
			html cssClass: (self open
				ifTrue: [ #shoreXPPanelSection ]
				ifFalse: [ #shoreXPPanelHiddenSection ]);
			tableData: [
				self renderOwnerOn: html
			] span: 2
		] ].

! !

WADecoration subclass: #ShoreRenderingTimeDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Useful'!

Form subclass: #ShoreForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreForm class methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 09:27'!
from: aForm

	| new |

	new := self extent: aForm extent depth: aForm depth bits: aForm bits.

	^ new! !

!ShoreForm methodsFor: 'as yet unclassified' stamp: 'pk 6/30/2005 11:17'!
asMIMEDocument 
	| aStream |
	aStream := RWBinaryOrTextStream on: ''.
	PNGReadWriter putForm: self onStream: aStream.
	^MIMEDocument contentType: 'image/png' content: aStream contents! !

Form subclass: #ShoreJpegForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ShoreComponents-Support'!

!ShoreJpegForm class methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 09:27'!
from: aForm

	| new |

	new := self extent: aForm extent depth: aForm depth bits: aForm bits.

	^ new
	! !

!ShoreJpegForm methodsFor: 'as yet unclassified' stamp: 'pk 7/6/2005 09:20'!
asMIMEDocument 
	| aStream writer |
	aStream := RWBinaryOrTextStream on: ''.
	writer := JPEGReadWriter2 on: aStream.
	writer nextPutImage: self quality: 100 progressiveJPEG: false.
	^MIMEDocument contentType: 'image/jpg' content: aStream contents! !
ShoreDemo1 initialize!
